import React from 'react';

var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

function formReducer(state, _ref) {
    var type = _ref.type,
        payload = _ref.payload;

    if ('TOTO' === type) {
        return _extends({}, state, {
            values: _extends({}, state.values, defineProperty({}, payload.name, payload.value))
        });
    }

    return state;
}

function useForm() {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref2$initialValues = _ref2.initialValues,
        initialValues = _ref2$initialValues === undefined ? {} : _ref2$initialValues;

    var initialState = {
        values: initialValues
    };

    var _React$useReducer = React.useReducer(formReducer, initialState),
        _React$useReducer2 = slicedToArray(_React$useReducer, 2),
        form = _React$useReducer2[0],
        dispatch = _React$useReducer2[1];

    return [form, dispatch];
}

export { useForm };
//# sourceMappingURL=index.es.js.map
